#include "config.h"
#include "misc.h"
#include "send.h"

/* we read this many bytes at a time. */
#define Block  4096

int parselog(char *LogLine, UserListType uptr, ChannelListType cptr, char *chan, char *nuh, char *command, char *rest, time_t start, time_t end)
{
   /* Use the parameters to decide to display the line or not. */
   /* This returns true if the line was displayed. */

   char* mychan;
   char* mynuh;
   char* mycommand;
   char* myrest;
   char* datestr;
   char *gmode;
   /* time_t mystart, myend;
    *Debug(DBGINFO, "Examining: %s", LogLine);
    */

   datestr = (char *) mysep(&LogLine, "]"); 
   mychan = (char *) mysep(&LogLine, " ");
   mynuh = (char *) mysep(&LogLine, " ");
   gmode = (char *) mysep(&LogLine, " ");
   mycommand = (char *) mysep(&LogLine, " ");
   myrest = (char *) mysep(&LogLine, "\0");

   if(!mycommand)
   {
       /*Debug(DBGINFO, "Invalid line in log input."); */
       return(0);
   }
/*
   if(!strcasecmp(mycommand, "LOGIN") || !strcasecmp(mycommand, "PASS") || !strcasecmp(mycommand, "RESETPASS") || !strcasecmp(mycommand, "SETPASS"))
   {
       myrest = "*******";
   }
*/
   if(cptr)
   {
      chan = cptr->Name;
   }
   /* It's a channel -- show only that channel's stuff. */
   if(!chan)
     chan = "";

   if(!nuh)
      nuh = "";
   if(!command)
      command = "";
   if(!rest)
      rest = "";
   if(*chan && strcasecmp(mychan, chan))
        return(FALSE);
   if(!myrest)
      myrest = "";
      
   send_to_user(uptr, "\002%s\002] %s %s \002%s\002 %s", datestr, mynuh, gmode, mycommand, myrest);
   return(TRUE);

}

int ShowLog(UserListType uptr, ChannelListType cptr, char *chan, char *nuh, char *command, char *rest, time_t start, time_t end, int maxlines)
{
   FILE *TheFile;
   int i, s, Last = FALSE, filelen, first;
   int line = 0, searchline = 0;
   int FilePosition;

   char Buff[Block+1] = "", PrevBuff[Block+1] = "";
   char LogLine[(Block+1)*2] = ""; /* To hold our exported results. */

   if(!(TheFile = fopen(AccountingLog, "r")))
   {
       send_to_user(uptr, "%s:%s", AccountingLog, strerror(errno));
       return(0);
   }
   s = fseek(TheFile, 0, SEEK_END); /* Start at the end. */
   filelen = ftell(TheFile); /* Find out the length. */
   FilePosition = 0; /* (from the bottom) */
   send_to_user(uptr, "=--- Command log ---=");
   while(Last == FALSE)
   {
       FilePosition += Block;
       if(FilePosition > filelen)
       {
          FilePosition = filelen;
          Last = TRUE;
       }
       if((s = fseek(TheFile, filelen-FilePosition, SEEK_SET)) < 0)
       {
          send_to_user(uptr, "%s:%s", AccountingLog, strerror(errno));
          fclose(TheFile);
          return(0);
       }
       s = fread(Buff, 1, Block, TheFile);
       Buff[Block] = '\0';
       if(ferror(TheFile))
       {
           send_to_user(uptr, "%s:%s", AccountingLog, strerror(errno));
           fclose(TheFile);
           return(0);
       }
       /* Now we parse the block backwards, when we find a line feed we spit out 
        * the line after it. If it's the last line, we want to check if we had any
        * left over bits from the previous block PrevBlock.
        * first == 1 until we find our first line feed, and if it is 0 we do the
        * check.
        */
       first = 1;
       for(i = s-1; i >= 0; i--)
       {
            if(Buff[i] == '\n')
            {
               Buff[i] = '\0';
               strcpy(LogLine, &Buff[i+1]);
               if(first)
                  strcat(LogLine, PrevBuff);
               first = 0;
               /* Debug(DBGINFO, "LOGLINE: %s", LogLine);
                * send_to_user(uptr, "LOGLINE: %s", LogLine);
                */
               searchline++;
               if(parselog(LogLine, uptr, cptr, chan, nuh, command, rest, start, end))
                 line++;
               if(line >= maxlines)
               {
                  send_to_user(uptr, "=--- Stopping at %d lines ---=", maxlines);
                  return(TRUE);
               }
               if( searchline >= MAXLOGSEARCHLENGTH )
               {
                   send_to_user(uptr, "=--- Data age limit reached ---=");
                   fclose(TheFile);
                   return(TRUE);
               }

            }
       }
       strcpy(PrevBuff, Buff); /* Save the remaining bit. */
   }
   send_to_user(uptr, "=--- End of log data ---=");
   fclose(TheFile);
   return(TRUE);
}
